package jp.co.argo21.nautica.workflow.soap;

import javax.annotation.Resource;
import javax.jws.WebService;
import javax.naming.NamingException;
import javax.xml.ws.WebServiceContext;
import org.apache.log4j.Logger;

import jp.co.argo21.nautica.workflow.omg.WorkflowException;
import jp.co.argo21.nautica.workflow.soap.message.User;
import jp.co.argo21.nautica.workflow.util.StringManager;

@WebService(serviceName = "UserManager",
        portName="UserManagerPort",
        endpointInterface = "jp.co.argo21.nautica.workflow.soap.UserManager",
        targetNamespace = "http://www.argo21.co.jp/nautica/workflow/soap",
        wsdlLocation = "WEB-INF/wsdl/UserManager.wsdl")
public class UserManagerSoapBindingImpl implements UserManager {

	/** ログ出力用オブジェクト */
	private static Logger log = Logger.getLogger(
			RoleManagerSoapBindingImpl.class);
	
	@Resource
    private WebServiceContext context;
	
	/**
	 * uidに対応するユーザを返す。
	 *
	 * @param uid ユーザID
	 * @return ユーザ
	 * @throws WorkflowException 
	 */
	@Override
	public User getUser(String uid) throws WorkflowException {
		
		String I1002 = StringManager.get("I1002")
			+ "(UserInstanceID=" + uid + ")";
		log.info(I1002);
		
		jp.co.argo21.nautica.workflow.security.User user = null;
		try {
			jp.co.argo21.nautica.workflow.security.UserManager userManager = SingletonServices.getInstance().getUserManager();
			user = userManager.getUser(uid);
		} catch (NamingException e) {
			String errMsg = StringManager.get("E1010");
			log.error(errMsg, e);
			throw new ServiceAccessorException(errMsg);
		}
		
		String I1005 = StringManager.get("I1005") 
			+ "(User=" + user + ")";
   	log.info(I1005);
		return new jp.co.argo21.nautica.workflow.soap.message.User(user);
		
	}

	public WebServiceContext getContext() {
		return context;
	}
	
}