package jp.co.argo21.nautica.workflow.soap.message;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;

import jp.co.argo21.nautica.workflow.dataaccess.OrganizationBean;
import jp.co.argo21.nautica.workflow.omg.WorkflowException;

public class Organization implements Serializable {
		
	private String id;
    private String name;
    private Map<String, String> attributes = new HashMap<String, String>();
    
    
	public Organization() {
		super();
	}
	
	public Organization(String id, String name, Map<String, String> attributes) {
		super();
		this.id = id;
		this.name = name;
		this.attributes = attributes;
	}
	
	public Organization(jp.co.argo21.nautica.workflow.security.Organization org) throws WorkflowException{
		this.id = org.getID();
		this.name = org.getName();
		String[] allKey = org.getAllAttributeNames();
		for (String key : allKey){
			attributes.put(key, org.getAttribute(key));
		}
	}
	
	
	public jp.co.argo21.nautica.workflow.security.Organization toDataaccessOrganizationBean(){
		OrganizationBean orgb = new OrganizationBean();
		orgb.setID(this.id);
		orgb.setName(this.name);
		Set<String> allKey = this.attributes.keySet();
		for (String key : allKey){
			orgb.setAttribute(key, this.attributes.get(key));
		}
		return (jp.co.argo21.nautica.workflow.security.Organization) orgb;
	}
	
	
	public String getId() {
		return id;
	}
	
	public void setId(String id) {
		this.id = id;
	}
	
	public String getName() {
		return name;
	}
	
	public void setName(String name) {
		this.name = name;
	}
	
	public Map<String, String> getAttributes() {
		return attributes;
	}
	
	public void setAttributes(Map<String, String> attributes) {
		this.attributes = attributes;
	}
    
}
