package jp.co.argo21.nautica.workflow.soap.message;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;

import jp.co.argo21.nautica.workflow.dataaccess.RoleBean;
import jp.co.argo21.nautica.workflow.omg.WorkflowException;

public class Role implements Serializable {
	
	private String id;
    private String name;
    private Map<String, String> attributes = new HashMap<String, String>();
    
    
	public Role() {
		super();
	}
	
	public Role(String id, String name, Map<String, String> attributes) {
		super();
		this.id = id;
		this.name = name;
		this.attributes = attributes;
	}
	
	
	public Role(jp.co.argo21.nautica.workflow.security.Role role) throws WorkflowException{
		this.id = role.getID();
		this.name = role.getName();
		String[] allKey = role.getAllAttributeNames();
		for (String key : allKey){
			attributes.put(key, role.getAttribute(key));
		}
	}
	
	
	public jp.co.argo21.nautica.workflow.security.Role toDataaccessRoleBean(){
		RoleBean roleb = new RoleBean();
		roleb.setID(this.id);
		roleb.setName(this.name);
		Set<String> allKey = this.attributes.keySet();
		for (String key : allKey){
			roleb.setAttribute(key, this.attributes.get(key));
		}
		return (jp.co.argo21.nautica.workflow.security.Role) roleb;
	}
	
	
	public String getId() {
		return id;
	}
	
	public void setId(String id) {
		this.id = id;
	}
	
	public String getName() {
		return name;
	}
	
	public void setName(String name) {
		this.name = name;
	}
	
	public Map<String, String> getAttributes() {
		return attributes;
	}
	
	public void setAttributes(Map<String, String> attributes) {
		this.attributes = attributes;
	}
	    
}
