package jp.co.argo21.nautica.workflow.soap.message;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Locale;
import java.util.Map;
import java.util.Set;

import jp.co.argo21.nautica.workflow.dataaccess.UserBean;
import jp.co.argo21.nautica.workflow.omg.WorkflowException;

public class User implements Serializable {

	private String id;
	private String firstname;
	private String lastname;
	private Map<String, String> attributes = new HashMap<String, String>();


	public User() {
		super();
	}


	public User(String id, String firstname, String lastname,
			Map<String, String> attributes) {
		super();
		this.id = id;
		this.firstname = firstname;
		this.lastname = lastname;
		this.attributes = attributes;
	}

	public User(jp.co.argo21.nautica.workflow.security.User user) throws WorkflowException{
		this.id = user.getID();

		String fullName = user.getName();
		String[] dividedName = null;
		if (Locale.getDefault().toString().equals("ja_JP")) {
			dividedName = fullName.split(" ", -1);
			this.lastname = dividedName[0];
			this.firstname = dividedName[1];
		} else {
			dividedName = fullName.split(", ", -1);
			this.lastname = dividedName[1];
			this.firstname = dividedName[0];
		}

		String[] allKey = user.getAllAttributeNames();
		for (String key : allKey){
			attributes.put(key, user.getAttribute(key));
		}
	}


	public jp.co.argo21.nautica.workflow.security.User toDataaccessUserBean(){
		UserBean userb = new UserBean();
		userb.setID(this.id);
		userb.setFirstName(this.firstname);
		userb.setLastName(this.lastname);
		Set<String> allKey = this.attributes.keySet();
		for (String key : allKey){
			userb.setAttribute(key, this.attributes.get(key));
		}
		return (jp.co.argo21.nautica.workflow.security.User) userb;
	}

	
	public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}

	public String getFirstname() {
		return firstname;
	}

	public void setFirstname(String firstname) {
		this.firstname = firstname;
	}

	public String getLastname() {
		return lastname;
	}

	public void setLastname(String lastname) {
		this.lastname = lastname;
	}

	public Map<String, String> getAttributes() {
		return attributes;
	}

	public void setAttributes(Map<String, String> attributes) {
		this.attributes = attributes;
	}
}
